Subject: bug#79116: 31.0.50; Crash on IGC build

From: Gerd Möllmann <[email-masked]>
Date: Fri, 01 Aug 2025 09:11:40 +0200

Helmut Eller <[email-masked]> writes:

> On Thu, Jul 31 2025, Gerd Möllmann wrote:
>
>> Hm, don't know what's best to do. At least it can't be the reason for
>> the current case, right?
>
> The assertion was:
>
>     AVER(RefSetSub(ScanStateUnfixedSummary(ss), SegSummary(seg))); /* <design/check/#.common> */
>
> It looks like MPS found a reference to a zone/generation that it was not
> expecting to find.  If something is able to by-pass memory barriers it
> could create such unexpected references.  Of course, I'm just
> speculating.  I don't even know how Pip figured out that this particular
> assertion failed.
>
> I would not change anything without a reproducible test case.  Could be
> tricky to create the problematic situation: the access must happen after
> the flip and not go through read-protected objects.

I think I agree. FWIW, I'm running tty Emacs all the time, so glyph
pools are in use, and I haven't see anything happening. But who knows...